close all;
clear all;
%% ROC of exp1
addpath('exp1_results');
LineStyles = {'--', ':', '-.', '-.*', '--o','-+','--x'};
figure();
%subplot(121);
hold on;  
% Other models
oa = load('dpAp_cd_fd_results_nan_inf.mat');
oa.cd = oa.cd/100;
oa.fd = oa.fd/100;

plot(oa.fd(2,:)',oa.cd(2,:)','LineWidth',8);
plot(oa.fd(7,:)',oa.cd(7,:)','LineWidth',7);
plot(oa.fd(4,:)',oa.cd(4,:)','LineWidth',6);

% BM model
vv = load('dpAp_results_vv.mat');
vv.cd = vv.cd/100;
vv.fd = vv.fd/100;
plot(vv.fd(8,:),vv.cd(8,:)','LineWidth',5);
plot(oa.fd(3,:)',oa.cd(3,:)','LineWidth',4);
plot(oa.fd(1,:)',oa.cd(1,:)','LineWidth',3);
plot(oa.fd(5,:)',oa.cd(5,:)','LineWidth',2);
plot(oa.fd(6,:)',oa.cd(6,:)','LineWidth',1);
 
axis([0 1 0.75 1.01])
%title('ROC');
xlabel('F');
ylabel('H');
fields = fieldnames(vv.thresholds);

legend('erblet','wavelet','Senef','Vencovsky','Lyon', 'DRNL','AR','matched','Location','SouthEast');
hold off;


%% Best results table
[dp_best, I_dp] = max(oa.dprime(1:7,:),[],2);
[dp_best(8), I_dp(8)] = max(vv.dprime(8,:),[],2);

[Ap_best, I_Ap] = max(oa.Ap(1:7,:),[],2);
[Ap_best(8),I_Ap(8)] = max(vv.Ap(8,:),[],2);

for i = 1:length(I_Ap)
    if i<8
        th_Ap(i) = oa.thresholds.(fields{i})(I_Ap(i));
        th_dp(i) = oa.thresholds.(fields{i})(I_dp(i));
        cd_dp(i) = oa.cd(i,I_dp(i));
        cd_Ap(i) = oa.cd(i,I_Ap(i));
        fd_dp(i) = oa.fd(i,I_dp(i));
        fd_Ap(i) = oa.fd(i,I_Ap(i));
    else
        th_Ap(i) = vv.thresholds.(fields{i})(I_Ap(i));
        th_dp(i) = vv.thresholds.(fields{i})(I_dp(i));
        cd_dp(i) = vv.cd(i,I_dp(i));
        cd_Ap(i) = vv.cd(i,I_Ap(i));
        fd_dp(i) = vv.fd(i,I_dp(i));
        fd_Ap(i) = vv.fd(i,I_Ap(i));
    end
end

% sort the results 
[dp_best, dp_sort] = sort(dp_best);
[Ap_best, Ap_sort] = sort(Ap_best);

algo = fields(1:8,1);
a = table(algo(dp_sort),dp_best,th_dp(dp_sort)',cd_dp(dp_sort)',fd_dp(dp_sort)', algo(Ap_sort), Ap_best,th_Ap(Ap_sort)',cd_Ap(Ap_sort)',fd_Ap(Ap_sort)');
a.Properties.VariableNames = {'Algo_dp_sorted','best_dp', 'best_dp_th','cd_dp','fd_dp', 'Algo_Ap_sorted', 'best_Ap', 'best_Ap_th','cd_Ap','fd_Ap'};
disp(a)

%% TIME MEASUREMENTS

t1 = load('time_measurements.mat');
t2 = load('time_measurements1.mat');
etime = cat(3,t1.etime,t2.etime);

t_at = mean(etime,3);
t_real = t_at*100/(90*0.8);

t_table = table(algo, t_at(:,1),t_at(:,2), t_real(:,1),t_real(:,2));
t_table.Properties.VariableNames = {'Algo', 't_at(dp_opt)','t_at(Ap_opt)','t_real(dp_opt)','t_real(Ap_opt)'};
disp(t_table);

t_allmean = mean(t_at,2);
t_realall = t_allmean*100/(90*0.8);

t_all_table = table(algo, t_allmean, t_realall);
t_all_table.Properties.VariableNames = {'Algo', 't_at(40 avg)', 't_real(40 avg)'};
disp(t_all_table);

%% ErrorBar with best values, mean and standard deviation
clear all;

% Plot the Ap data withs error bars and labels
figure(1);

ORDERING = [5 6 7 8 1 3 4 2];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% EXP 1
% Other models
oa = load('dpAp_cd_fd_results_nan_inf.mat');
oa.cd = oa.cd/100;
oa.fd = oa.fd/100;

% BM model
vv = load('dpAp_results_vv.mat');
vv.cd = vv.cd/100;
vv.fd = vv.fd/100;

Ap_om = oa.Ap(1:7,:);
Ap_vv = vv.Ap(8,:);

% Replace +-inf and 0 values with NaN in Ap_om
Ap_om(isinf(Ap_om) | Ap_om == 0) = NaN;

% Replace +-inf and 0 values with NaN in Ap_vv
Ap_vv(isinf(Ap_vv) | Ap_vv == 0) = NaN;

% Calculate mean and standard deviation of each row of Ap_om and Ap_vv
mean_om = mean(Ap_om, 2,'omitnan'); % calculate mean along each row (dimension 2), ignoring NaN values
std_om = std(Ap_om, 0, 2,'omitnan'); % calculate standard deviation along each row (dimension 2), ignoring NaN values
mean_vv = mean(Ap_vv, 2,'omitnan'); % calculate mean along the only row of Ap_vv, ignoring NaN values
std_vv = std(Ap_vv, 0, 2,'omitnan'); % calculate standard deviation along the only row of Ap_vv, ignoring NaN values

means = [mean_om ; mean_vv];
stds = [std_om ; std_vv];


[best1 idb1] = max(Ap_om,[],2,'omitnan');
[worst1 idw1] = min(Ap_om,[],2,'omitnan');

[best2 idb2] = max(Ap_vv,[],2,'omitnan');
[worst2 idw2] = min(Ap_vv,[],2,'omitnan')
bests = [best1; best2];
worsts = [worst1; worst2];


bests = bests(ORDERING);
worsts = worsts(ORDERING);
means = means(ORDERING);
stds = stds(ORDERING);


labels = {'DRNL', 'ERBlet', "Lyon's", "Seneff's", 'AR', 'Matched', 'Wavelet', "Vencovsky's"};
labels = labels(ORDERING);

x = 1:length(labels);

h3 = errorbar(x-0.05, means , stds, '^', 'MarkerSize', 6, 'LineWidth', 2);
set(h3, 'MarkerSize', 6, 'LineWidth', 3, 'Color', 'g');

font_size = 16
% Add labels for the Ap data
for i = 1:length(x)
    text(x(i) + 0.1, bests(i), sprintf('%.4f', bests(i)), 'Color', 'g', 'FontSize', font_size);
end
% % Add labels for the Ap data
% for i = 1:length(x)
%     text(x(i) + 0.1, worsts(i), sprintf('%.4f', worsts(i)), 'Color', 'g', 'FontSize', font_size);
% end

% Change x-axis labels
set(gca, 'XTick', x)
set(gca, 'XTickLabel', labels,'FontSize', 14)
legend('Experiment 1','Location', 'SouthWest');

%title('Experiment 1 Results');
xlabel('Algorithm');
ylabel("A' value");


