close all;
clear all;


addpath("Results");

ORDERING = [5 6 7 8 1 3 4 2];
font_size = 16

%% EXPERIMENT 2 and 3 MEAN and Standard Deviation Figure

labels = {'DRNL', 'ERBlet', "Lyon's", "Seneff's", 'AR', 'Matched', 'Wavelet', "Vencovsky's"};
labels = labels(ORDERING);


x = 1:length(labels);
om1 = load('REV1_results.mat');
om2 = load('REV1_results_v2.mat');
om3 = load('REV1_results_v3.mat');
om4 = load('REV1_results_v4.mat');
om5 = load('REV1_results_v5.mat');

vv1 = load('REV1_results_VV.mat');
vv2 = load('REV1_results_VV_2.mat');
vv3 = load('REV1_results_VV_3.mat');
vv4 = load('REV1_results_VV_4.mat');
vv5 = load('REV1_results_VV_5.mat');

om5050 = load('REV1_results_50_50.mat');
om5050_2 = load('REV1_results_50_50_v2.mat');
om5050_3 = load('REV1_results_50_50_v3.mat');
om5050_4 = load('REV1_results_50_50_v4.mat');
om5050_5 = load('REV1_results_50_50_v5.mat');

vv5050 = load('REV1_results_VV_50_50.mat');
vv5050_2 = load('REV1_results_VV_50_50_v2.mat');
vv5050_3 = load('REV1_results_VV_50_50_v3.mat');
vv5050_4 = load('REV1_results_VV_50_50_v4.mat');
vv5050_5 = load('REV1_results_VV_50_50_v5.mat');

%%% Aprime results

%75 - 25 
Ap_om = cat(2,om1.Ap_test(:,:,1),om2.Ap_test(:,:,1),om3.Ap_test(:,:,1),om4.Ap_test(:,:,1),om5.Ap_test(:,:,1));
Ap_om(8,:) = [vv1.Ap_test(8,:,1) vv2.Ap_test(8,:,1) vv3.Ap_test(8,:,1) vv4.Ap_test(8,:,1) vv5.Ap_test(8,:,1)];

Ap_means = mean(Ap_om,2);
Ap_std = std(Ap_om,0,2);
Ap_means = Ap_means(ORDERING);
Ap_std = Ap_std(ORDERING);
%50 - 50
Ap_om5050 = [om5050.Ap_test(:,:,1) om5050_2.Ap_test(:,:,1) om5050_3.Ap_test(:,:,1)  om5050_4.Ap_test(:,:,1)  om5050_5.Ap_test(:,:,1)];
Ap_om5050(8,:) = [vv5050.Ap_test(8,:,1) vv5050_2.Ap_test(8,:,1) vv5050_3.Ap_test(8,:,1) vv5050_4.Ap_test(8,:,1) vv5050_5.Ap_test(8,:,1)];

% Compute mean and standard deviation for the Ap data with 50-50
Ap_means5050 = mean(Ap_om5050,2);
Ap_means5050 = Ap_means5050(ORDERING);
Ap_std5050 = std(Ap_om5050,0,2);
Ap_std5050 = Ap_std5050(ORDERING);

figure(2);
%subplot(122);

h = errorbar(x - 0.05, Ap_means, Ap_std, 'o', 'MarkerSize', 8, 'LineWidth', 2);
set(h, 'MarkerSize', 8, 'LineWidth', 4, 'Color', [0 0.5 0] );
hold on;

% Plot the Ap data with 50-50 with error bars and labels
h2 = errorbar(x + 0.05, Ap_means5050, Ap_std5050, 'x', 'MarkerSize', 8, 'LineWidth', 2);
set(h2, 'MarkerSize', 8, 'LineWidth', 2, 'Color',  [0.5 0 0.5]);

% Add labels for the Ap data
for i = 1:length(x)
    text(x(i)-0.45, Ap_means(i), sprintf('%.4f', Ap_means(i)), 'Color', h.Color, 'FontSize', font_size);
end

% Add labels for the Ap data with 50-50
for i = 1:length(x)
    text(x(i) + 0.1, Ap_means5050(i), sprintf('%.4f', Ap_means5050(i)), 'Color', h2.Color, 'FontSize', font_size);
end

% Add a legend
legend('Experiment 2', 'Experiment 3', 'Location', 'SouthWest');

% Change x-axis labels
set(gca, 'XTick', x)
set(gca, 'XTickLabel', labels,'FontSize', 14)

% Add a title and axis labels
%title('Experiment 2 and Experiment 3 Results');
xlabel('Algorithm');
ylabel("A' value");


%% EXPERIMENT 2 and 3 Table

% CD FD
%75 - 25 
cd_om = cat(2,om1.cd_test(:,:,1),om2.cd_test(:,:,1),om3.cd_test(:,:,1),om4.cd_test(:,:,1),om5.cd_test(:,:,1));
cd_om(8,:) = [vv1.cd_test(8,:,1) vv2.cd_test(8,:,1) vv3.cd_test(8,:,1) vv4.cd_test(8,:,1) vv5.cd_test(8,:,1)];

cd_means = mean(cd_om,2);
cd_std = std(cd_om,0,2);

fd_om = cat(2,om1.fd_test(:,:,1),om2.fd_test(:,:,1),om3.fd_test(:,:,1),om4.fd_test(:,:,1),om5.fd_test(:,:,1));
fd_om(8,:) = [vv1.fd_test(8,:,1) vv2.fd_test(8,:,1) vv3.fd_test(8,:,1) vv4.fd_test(8,:,1) vv5.fd_test(8,:,1) ];

fd_means = mean(fd_om,2);
fd_std = std(fd_om,0,2);

%50 - 50

cd_om5050 = [om5050.cd_test(:,:,1) om5050_2.cd_test(:,:,1) om5050_3.cd_test(:,:,1) om5050_4.cd_test(:,:,1) om5050_5.cd_test(:,:,1)];
cd_om5050(8,:) = [vv5050.cd_test(8,:,1) vv5050_2.cd_test(8,:,1) vv5050_3.cd_test(8,:,1) vv5050_4.cd_test(8,:,1) vv5050_5.cd_test(8,:,1)];

cd_means5050 = mean(cd_om5050,2);
cd_std5050 = std(cd_om5050,0,2);

fd_om5050 = [om5050.fd_test(:,:,1) om5050_2.fd_test(:,:,1)];
fd_om5050(8,:)= [ vv5050.fd_test(8,:,1) vv5050_2.fd_test(8,:,1)];

fd_means5050 = mean(fd_om5050,2);
fd_std5050 = std(fd_om5050,0,2);

% Sort Ap_om in ascending order
[sorted_Ap_means, idx_Ap_means] = sort(Ap_means);
sorted_labels_Ap_means = labels(idx_Ap_means)';
cd_sorted = cd_means(idx_Ap_means);
fd_sorted = fd_means(idx_Ap_means);
Ap_std_sorted = Ap_std(idx_Ap_means);

% Display the table for Ap_om in ascending order
table_Ap_means = table(sorted_labels_Ap_means,cd_sorted,fd_sorted, sorted_Ap_means, Ap_std_sorted);
disp("Table for Ap_means in ascending order:");
disp(table_Ap_means);

% Sort Ap_om5050 in ascending order
[sorted_Ap_means5050, idx_Ap_means5050] = sort(Ap_means5050);
sorted_labels_Ap_means5050 = labels(idx_Ap_means5050)';
cd_sorted_5050 = cd_means5050(idx_Ap_means5050);
fd_sorted_5050 = fd_means5050(idx_Ap_means5050);
Ap_std_sorted5050 = Ap_std5050(idx_Ap_means5050);

% Display the table for Ap_means5050 in ascending order
table_Ap_means5050 = table(sorted_labels_Ap_means5050, cd_sorted_5050, fd_sorted_5050, sorted_Ap_means5050,Ap_std_sorted5050);
disp("Table for Ap_means5050 in ascending order:");
disp(table_Ap_means5050);


%%




% 
% % Find maximum, minimum, and non-zero mean values for each row
% [Ap_om_max, Ap_om_max_idx] = max(Ap_om, [], 2);
% [Ap_om_min, Ap_om_min_idx] = min(Ap_om(Ap_om ~= 0 & ~isnan(Ap_om) & ~isinf(Ap_om)), [], 2);
% Ap_om_mean = mean(Ap_om(Ap_om ~= 0 & ~isnan(Ap_om) & ~isinf(Ap_om)), 2);
% 
% [Ap_om5050_max, Ap_om5050_max_idx] = max(Ap_om5050, [], 2);
% [Ap_om5050_min, Ap_om5050_min_idx] = min(Ap_om5050(Ap_om5050 ~= 0 & ~isnan(Ap_om5050) & ~isinf(Ap_om5050)), [], 2);
% Ap_om5050_mean = mean(Ap_om5050(Ap_om5050 ~= 0 & ~isnan(Ap_om5050) & ~isinf(Ap_om5050)), 2);
% 
% [cd_om_max, cd_om_max_idx] = max(cd_om, [], 2);
% [cd_om_min, cd_om_min_idx] = min(cd_om(cd_om ~= 0 & ~isnan(cd_om) & ~isinf(cd_om)), [], 2);
% cd_om_mean = mean(cd_om(cd_om ~= 0 & ~isnan(cd_om) & ~isinf(cd_om)), 2);
% 
% [fd_om_max, fd_om_max_idx] = max(fd_om, [], 2);
% [fd_om_min, fd_om_min_idx] = min(fd_om(fd_om ~= 0 & ~isnan(fd_om) & ~isinf(fd_om)), [], 2);
% fd_om_mean = mean(fd_om(fd_om ~= 0 & ~isnan(fd_om) & ~isinf(fd_om)), 2);
% 
% [cd_om5050_max, cd_om5050_max_idx] = max(cd_om5050, [], 2);
% [cd_om5050_min, cd_om5050_min_idx] = min(cd_om5050(cd_om5050 ~= 0 & ~isnan(cd_om5050) & ~isinf(cd_om5050)), [], 2);
% cd_om5050_mean = mean(cd_om5050(cd_om5050 ~= 0 & ~isnan(cd_om5050) & ~isinf(cd_om5050)), 2);
% 
% [fd_om5050_max, fd_om5050_max_idx] = max(fd_om5050, [], 2);
% [fd_om5050_min, fd_om5050_min_idx] = min(fd_om5050(fd_om5050 ~= 0 & ~isnan(fd_om5050) & ~isinf(fd_om5050)), [], 2);
% fd_om5050_mean = mean(fd_om5050(fd_om5050 ~= 0 & ~isnan(fd_om5050) & ~isinf(fd_om5050)), 2);
% 
% 
% Ap_om_min_s =  Ap_om_min(idx_Ap_means);
% Ap_om_max_s =  Ap_om_max(idx_Ap_means);
% 
% Ap_om5050_min_s =  Ap_om5050_min(idx_Ap_means5050);
% Ap_om5050_max_s =  Ap_om5050_max(idx_Ap_means5050);
% 
% cd_om_min_s =  cd_om_min(idx_Ap_means);
% cd_om_max_s =  cd_om_max(idx_Ap_means);
% 
% fd_om_min_s =  fd_om_min(idx_Ap_means);
% fd_om_max_s =  fd_om_max(idx_Ap_means);
% 
% fd_om5050_min_s =  fd_om5050_min(idx_Ap_means5050);
% fd_om5050_max_s =  fd_om5050_max(idx_Ap_means5050);
% 
% cd_om5050_min_s =  cd_om5050_min(idx_Ap_means5050);
% cd_om5050_max_s =  cd_om5050_max(idx_Ap_means5050);
% 
% table_Ap = table(sorted_labels_Ap_means,Ap_om_min_s,sorted_Ap_means, Ap_om_max_s,cd_om_min_s,cd_sorted,cd_om_max_s,fd_om_min_s,fd_sorted,fd_om_max_s);
% disp(table_Ap);
% 
% table_Ap_5050 = table(sorted_labels_Ap_means5050,Ap_om5050_min_s,sorted_Ap_means, Ap_om5050_max_s,cd_om5050_min_s,cd_sorted,cd_om5050_max_s,fd_om5050_min_s,fd_sorted,fd_om5050_max_s);
% disp(table_Ap_5050);