cd = [26.47
82.35
85.29
82.35
82.35
88.24
88.24
85.29
76.47
85.29
94.12
94.12];

fd = [7.69
38.46
38.46
23.08
10.26
15.38
15.38
7.69
2.56
5.13
10.26
5.13];

dp = [0.797
1.222
1.342
1.665
2.196
2.207
2.207
2.475
2.671
2.682
2.832
3.197];

cd = cd'/100;
fd = fd'/100;

dp = norminv(cd)-norminv(fd); % no bias included


% Beta  - When subjects favor neither the yes response nor the no
% response, beta= 1. less than 1 signify a bias toward
% responding yes, whereas values of greater than 1 signify
% a bias toward the no response.
beta = exp((norminv(fd).^2-norminv(cd).^2)./2);

% c 
c = -(norminv(cd)+norminv(fd))/2;

% A_dprime
% One method involves using d' to
% estimate the ROC area; the resulting measure is called Ad"
% This measure is valid only when the d' assumptions are
% met.
Adp = normpdf(dp/sqrt(2));

% A_prime - nonparametric ROC without any assumptions
for i = 1:length(cd)
   Ap(i) = 0.5 + sign(cd(i)-fd(i))*((cd(i)-fd(i))^2 + abs(cd(i)-fd(i)))/(4*max(cd(i),fd(i))-4*cd(i)*fd(i));
end

% b_primeprime
bpp = sign(cd-fd).*(cd.*(1-cd)-fd.*(1-fd))./(cd.*(1-cd)+fd.*(1-fd));



t = table(cd',fd',dp',beta',c',Adp',Ap',bpp');
t.Properties.VariableNames = {'cd','fd','dp','beta','c','Adp','Ap','bpp'};
t.Properties.RowNames = {'c1','c2','c3','matched','lopez','lyon','AR','VV','drnl','seneff','wavelet','erblet'};
t





